  
        /*           For PIC12F629 
               REMOTE CONTROLLED LIGHT */
           
#include "inpic.h"

#include "io12f629.h"
  
     
     
unsigned char ACTIVE;     //remote or button are pressed
unsigned char ZADER; 
unsigned char DEL;        //delay of impulse to triac

unsigned char round=0;
unsigned const char roundlim = 3;//4??????

unsigned short count;     //counter of half-periods of AC
unsigned short bigcount;  //half-periods when not operated

unsigned short cou;       //counter of first pressing
unsigned short cou1;      //counter of second pressing
unsigned short depr;      //time between 1 and 2 pressings

unsigned char press;      //remote pressed 1 or not 0

unsigned char toyou;      //to TV(0) or to you(1)


unsigned const char max=210;  //min bright  (!!!!250  is limit!!!) 
unsigned const char min=70;   // max bright  

unsigned char IMP;            //catch AC zerocrossing


unsigned char OLDACT;         //variable for control of changing of ACTIVE
unsigned char OLDTMR;         //variable for control of changing of TMR0
unsigned char KEEPTMR;        //variable for control of changing of TMR0

unsigned char direction=0;    //dimming-rising

unsigned char deb;            //debouncing delay when not press
unsigned char debou;          //debouncing delay when press

unsigned char serv;           //service variable
unsigned char serv1;          //service variable1

unsigned short countyou;      //count of  time of  "toyou" statement
unsigned long turnoff;        //time of dark

unsigned short big=0;           //counter that turn off after 8 hours after last operating 
unsigned char bigg=0;           //counter that turn off after 8 hours after last operating

unsigned char wassub;         // indicator  "was in impulse  subroutine"
unsigned char wasrem;         //indicator "was remote"
unsigned char wasbutton;      //indicator "was button"
unsigned char wasslide;       //indicator "was slide"
unsigned char release;        //release of IR remote when operate
unsigned char wasone;         //was positive half-period


unsigned short number;        //for 'wait' subroutine 
unsigned short current;       //for 'wait' subroutine 
 
unsigned char dehi;           // hi byte of remotedelay;
unsigned char delow;          //low byte of remotedelay;
unsigned char changwai;       //indiator of entrance in regyme of programming
 unsigned short remotedelay;  //delay of operating from remote 
  
  
  
  
  
  

  
  
  
  
   
   
   //delay subroutine
   wait (number)
   {
      for (current=0;current<number;current++);//lets spend a time
   }
   
   
   
     void beep (serv1) //a little signal.Duration and frequency depends of serv1.
  
   {
         for (serv=0;serv<30;serv++)
           {
                        // XOR
            GPIO = GPIO ^ 32; //changing of GP5
            
            wait (serv1);
             
           }
        
        GPIO = 0;
    }
   
   
   
   
   //waiting of zerocrossing and giving  impulse to triac
  impulse(void)
  {  unsigned char hi;   //service variable
     unsigned char low;  //service variable 
                                                                                                                                                                                                                                        
  if (!wasone)           //if now is positive half-period
  { 
       hi=0;
       low=0;
       
    //wait while 1 on pin7
   waitofzero: IMP = COUT;          //reading comparator on pin 7 (GP0)
              if (IMP)
                { 
                  low=0;
                  goto  waitofzero; //loop if 1 on pin7
                 }
              else                  // low level on pin 7
                 {
                  low++;  
                  if (low<5) goto waitofzero; //low level on pin 7 must be at least 5 times
                  }
                  
    //wait while 0 on pin7 . Catching of begining of positive half-period  
    waitofone: IMP = COUT;          //reading comparator on pin 7 (GP0)
              if (!IMP)             //loop if 0 on pin7. Waiting of rizing
                 {
                   hi=0;
                   goto  waitofone;  //loop if 0 on pin7
                  }
              else                  // Hight level on pin 7
                 {
                   hi++;
                   if (hi<5) goto waitofone;//Hight level on pin 7 must be at least 5 times
                 }
                                
                  
              TMR1H=0;      //reset of TMR1    
              TMR1L=0;      //reset of TMR1    
              wasone = 1;   //set indicator "was positive half-period"
              
                  
                                          //1 gives 26uS
     for (ZADER = 1;ZADER<DEL;ZADER++)  wait (1);  //delay depends of DEL
   
    
           if (DEL<max)           //bearning triac if bright is not minimum 
               {
                KEEPTMR = TMR0;   //IR sensor can give false impulse when triac burns.
                                  //To neutralize this effect let's keep value of TMR0   
                GPIO = 2;         //triac burning  GP1 pin6
                wait (15);        //duration of impulse to triac. 15 gives 200uS; 
                GPIO = 0;         //end of impulse to triac
                
                TMR0 = KEEPTMR ;  //restore of value of TMR0
               }
           else GPIO = 0;         // do nothing if bright is  minimum    
   }
              
  else  //if before was positive half-period
   { 
     while (TMR1H < 39 );//elapsed time from positive front (5000 tacts = 5mS=half-period)
     wasone = 0;                  //reset of indicator "was positive half-period"
     
                                               //1 gives 26uS
     for (ZADER = 1;ZADER<DEL;ZADER++)  wait (1); //delay depends of DEL
   
    
           if (DEL<max)           //bearning triac if bright is not minimum  
               { 
                KEEPTMR = TMR0;   //IR sensor can give false impulse when triac burns.
                                  //To neutralize this effect let's keep value of TMR0    
                GPIO = 2;         //triac burning  GP1 pin6
                wait (15);        //duration of impulse to triac 15 gives 200uS; 
                GPIO = 0;         //end of impulse to triac
                
                TMR0 = KEEPTMR;   //restore of value of TMR0
               }
           else GPIO = 0;         // do nothing if bright is  minimum 
    }          
     
    wassub = 1;                  //program was in subroutine 
 }

  
  
  
   //Reading of memory
   char readmem( char addr )
 {    
    //adr0 -  slided, adr1 - current(for restart after WDT)
    //adr 2and 3 for remotedelay
    RP0 = 1;          //page switching
    EEADR=addr;
    RD =1;            //set bit (EECON1,RD)
    serv = EEDATA;
    RP0 = 0;          //page switching
    return serv;
 }
   
   
    //Writing of memory
     writemem(char addr)
   {    
      //adr0 -  slided, adr1 - current 
      //adr 2and 3 for remotedelay
    GIE = 0;//disable interruption
      
    RP0 = 1;
     
    EEADR = addr;
    EEDATA = serv1;
    
    WREN = 1;       //set bit( EECON1, WREN ). Disable protection of writing
    EECON2 = 0x55;
    EECON2 = 0xAA;
    WR = 1;         //writing begins 
    
    WREN = 0;       //writing protect

    RP0 = 0;
    
   }

       
   
   onoff(void)  //on and off subroutine
   {
         serv = readmem(0);          //memorized bright. If was double click
     
     
       if (serv1==255) serv = min;  //if was only one click and DEL=max (turned off) 
                                    //then turn to the maximum bright (NEEDED FOR DOUBLECLICK)
                      
       if (serv1 == 250) serv = max;//if was only one click and DEL!=max (turned on)
                                    //then turn to the minimum bright (NEEDED FOR DOUBLECLICK)
               serv1=0;                 //reset (NEEDED FOR DOUBLECLICK)
        
    
            
        
            direction=0;            //for OFF in future
        
          if (serv>(max-50)) direction=1;//if bright is near of minimum (for ON in future)
         
               
        
      if (DEL==max)                 //if  bright is minimum
      {                        
          for (DEL=max;DEL>=serv;DEL=DEL-1) //slow increasing of bright 
             {
              impulse();            //turn on
              __clear_watchdog_timer();
             }
      }
      
      else                          //if  bright is NOT minimum 
      { 
        //(DEL=DEL;DEL<=serv;DEL=DEL+3) (NEEDED FOR DOUBLECLICK) 
      for (DEL=DEL;DEL<=serv;DEL=DEL+3)//slow decreasing of bright(DEL=serv;DEL<=max;DEL=DEL+3)
          {
           impulse();                  //turn off
           __clear_watchdog_timer();
          }
      }
       
   }
                                         
   
   
   slide(void)
   {
     wasslide=1;                  //indicator "was slide"
         
       if  (round==roundlim)      //for slowing in 3 times regulation
        {
         if (direction) DEL++;    //direction=1 -> dime
         else DEL--;              // direction=0 -> rise
         }  
    }







 
 main  (c_tack)//???
 
{
__set_configuration_word(0x114C);
                        // b'01000101001100'
                        //FOSC0 = 0  INTOSC generator  
                        //FOSC0 = 0  INTOSC generator            
                        //FOSC1 = 1  INTOSC generator 
                        //WDTE  = 1  WDT enabled 
                        //-PWRTE= 0  PWRTE enabled
                        //MCLRE = 0  internal MCLR
                        //BODEN = 1  BOR enabled
                        //-CP   = 0  code protect on
                        //-CPD  = 1  EEPROM  protect  disabled
                        //absent  0
                        //absent  0
                        //absent  0
                        //BG0  =  1 
                        //BG1  =  0 
  
                        
  RESTART:        //go here when something wrong
      
      toyou=0;      //indicator "toyou"
      wasrem=0;     //indicator "was remote"
      wasslide=0;   //indicator "was slide"
      release=0;    //release of IR remote when operate
      deb=0;        //debouncing delay when not press
      debou=0;
      cou=0;        //counter of half-periods when operated
      press=0;      //remote or button pressed 1 or not 0
      count=0;      //counter of half-periods of AC
      bigcount=0;   //half-periods when not operated
      countyou=0;   //count of  time of  "toyou" statement
      wasone = 1;
      changwai = 0;
      ACTIVE = 0; 
   
  
  
      DEL = readmem(1); //start whith memorized bright ( when wdt resets)
      
      //initializing of remotedelay
                         //if remotedelay>40s
 if ((readmem(4)!=0xAB) || (readmem(2)>15) || ((readmem(2)==0)&&(readmem(3)==0))) 
         {                                  
            __clear_watchdog_timer ();
            serv1=0;        //initial remotedelay = 2.5s
            writemem (2);
            wait (2000);    //pause 22mS
     
            __clear_watchdog_timer ();
            serv1=250;      //initial remotedelay = 2.5s
            writemem (3);
            wait (2000);    //pause 22mS
            
            __clear_watchdog_timer ();
            serv1=0xAB;     //indicator 'initial value of remotedelay yet programmed'
            writemem (4);
            wait (2000);    //pause 22mS
           }
          
      dehi = readmem(2);              //hi byte of remotedelay
      delow = readmem(3);             //low byte of remotedelay
      remotedelay = (dehi<<8)| delow; //compose remotedelay from hi and low bytes
   
       
      
   if ((DEL>(max+3)) || (DEL<(min-3)))  //memory value is out of range
   {
     __clear_watchdog_timer ();
     DEL=150;                         //set bright to average
     
     serv1 = DEL;
     writemem (0);                    //memorizing of 'slided' value of bright
     wait (2000);                     //pause 22mS
     
     __clear_watchdog_timer ();
     writemem (1);                    //memorizing of current value of bright
     wait (2000);                     //pause 22mS
    }                  
   

                                        
  LOOP:            //loop forever 
  
   //initialization of registers
   GIE = 0;              //disable interrupt
     
   T1CON = 1;            //enable TMR1
      
   CMCON = 14;           //00001110 enable comparator 
   
   
   RP0 = 1;              //switch page 1
  
  asm ("call 0x3FF") ;   //calibrating of OSCCAL
  asm ("movwf 0x90") ;   //calibrating of OSCCAL
    
  GIE = 0;               //disable interrupt
  
  VRCON = 0xA0;          //CVref circuit powered up & Cvref=0 

  TRISIO = 13;           //001101b 1-input; 0 - output
  
  
  
           //initializing OPTION register 10111110b;                                
      OPTION = 0xBE;            // PS0=0
                                // PS1=1 switch WDT to prescaller 1:64.
                                // PS2=1
                                // PSA=1 prescaller connected to WDT
                                // T0SE=1 RTCC increments by negative front
                                // T0SC=1 RTCC connected to GP2 
                                // INTEDG=0 interrupt on negative front on pin INT GP2
                                // GPPU=1 internal loads of port GPIO DISconnected
                             
  RP0 = 0;  //switch page 0
  
  
  if ((!changwai)&&(wasrem)&&(count==1))   //reading remotedelay from EEPROM
    {
     dehi = readmem(2);                    //hi byte of remotedelay
     delow = readmem(3);                   //low byte of remotedelay
     remotedelay = (dehi<<8)| delow;       //compose remotedelay from hi and low bytes
     }
  
   //slowing  regulation in 3 times. See slide()
   round++;
   if (round>roundlim)  round=0;


  //little sound after 4sec when command was from remote control
   if ((bigcount==400)&&(release))  beep(80);
   
 
  //reset of toyou after 4 S when operated from remote
  // or after 0.5 s when operated from button             //bigcount>50(NEEDED FOR DOUBLECLICK)
  if (((bigcount==400)&&(release)) || ((!release)&&(!press)&&(bigcount>50)))//2
  {               
   toyou=0;           //4sec after last command from remote,then standby
   countyou=0;        //reset of  counter of "toyou  statement"  
   release=0;         //  reset of 'release' indicator
   changwai=0;        //reset of 'change of time of waiting of remote' indicator
   }
    
    
              // bigcount>50(NEEDED FOR DOUBLECLICK) 2
  if (bigcount>50)//when not pressed over 0.5s 
   {
    wasbutton = 0;    //reset of indicator "was button"
    wasrem = 0;       //reset of indicator "was remote"
    }
   
    
        // turn off after 8 hours
    if ((!toyou)&&(DEL<max)) big++; //turn off after 8 hours if not off( DEL==max)
    if (big==65455) bigg++;         //time after last operating
    if (bigg>65)                    //43->(44*65455*10ms)= 8h 00m 0.2s
    {                               //65->(66*65455*10ms)=12h 00m 0.3s
     big=0;                         //reset of counters
     bigg=0;                        //reset of counters
     serv1 = 250;                   //see onoff(). Bright goes to minimum
     onoff();                        //call subroutine  onoff()
     serv1 = max;                      
     writemem (1);                  //memorizing current bright (off)
    } 
    
     
       //reading button
       serv = (GPIO&8);                  //reading GP3 (BUTTON)
       if (!serv)                        //zero if button is pressed
       {
        ACTIVE++;                        //increments when button is pressed
        wasbutton = 1;                   //set indicator 'was button'
        }

       //reading remote. Remote increments RTCC TMR0 when active
       if ((TMR0!=OLDTMR)&&(!wasbutton)) //if remote is active then RTCC changes 
         {                               //and button must not to be pressed
           ACTIVE++;                     //increments when remote is active
           wasrem=1;                     //set of indicator "was remote" 
          }
              
        OLDTMR=TMR0;                     //memorizing of value of TMR0
   
        
      

     //debouncing block
   if ((ACTIVE != OLDACT))               // if IR remote or button is pressed 
                     
   { 
    debou++;                             //count of pressing time
    OLDACT = ACTIVE;                     //memorizing of value 
    deb=0;                               //reset of debouncing variable
    if (debou>5)                         //if time of pressing if over 50mS
     {
      press=1;                           //indicator of pressing is set after 0.05sec
      debou=0;
      }
   }
    
    else                                 //nothing is pressed
    {        
       deb++;                            //count of not pressing time
       if (deb>20)                       //if not pressed over 200 mS
      {        
       deb=0;                            //reset of debouncing variable
       press=0;                          //pressing indicator reset
       debou=0;
      }
        
    }
    
    
    
           //time of pressing or depressing
  if (press)                      //remote or button is pressed for short or long time
   { 
    count++;                      //how long remote or button pressed 
    bigcount=0;                   //reset of counter of NOT pressed time
    }
     
   else                           // remote or button are not pressed 
   {
    bigcount++;                   //how long remote or button NOT pressed
    if (bigcount>65000) bigcount = 65000; //protection from overflow
    count=0;                      //reset of counter of pressed time
    }
    
    
      
   //if ((count==1)&&(wasbutton)) beep (2); //imitation of sound of button
   
   
                  
  if (((count>=remotedelay)) || ((press)&&(!wasrem)))//remote pressed over than
                                                     //time of remotedelay
  {
   toyou=1;                                          //yes,to you, mister switch
   big=0;                                            //reset of 'big' when operated
   bigg=0;                                           //reset of 'bigg' when operated
  }              

     //block of changing of remotedelay           
   if ((count==6000)&&(wasrem))   //if remote is pressed continiousely over 1min
   {
     release = 0;
     changwai =1;                //indicator "changing of time of waiting of remote"
     
       //sound "ready for programming dehi and delow"
       for (serv1=50;serv1>1;serv1--)
         { 
          beep (serv1);
           __clear_watchdog_timer();
          }
    
    }
    
    
    if ((changwai)&&(release)&&(count>0))
        {
         dehi = count>>8;                  //extracting of hi byte of 'count'
         delow = count&0x00ff;             //extracting of low byte of 'count'
         }
         
             
    if ((release==2)&&(changwai))          //memorizing of time of waiting of remote
    {   if (dehi>15) { dehi=0; delow=250;} //limit equal to 2.5s if remote delay is over 40 s
    
       serv1 = dehi;    //hi byte of remotedelay
       writemem (2);    //memorizing of new time of waiting of remote
     
       wait (2000);     //pause 22ms
     
       serv1= delow;    //low byte of remotedelay
       writemem (3);    //memorizing of new time of waiting of remote
       
       
         for (serv1=1;serv1<50;serv1++)//sound "end of programming"
            { 
             beep (serv1);
             __clear_watchdog_timer();
            }     
     
       changwai = 0; //reset of indicator "changing of time of waiting of remote" 
      }  
  
  
        //little sound when ready to operate from remote
  if ((wasrem)&&(!release)&&(count==remotedelay)) beep(50);        
    
    
    
 if (toyou)   //remote pressed for long time or button pressed
 {    
     countyou++;                          //count of  time of  "toyou" statement
      if (countyou>12000) goto RESTART;   //restart when  very long time (2 min)  
                                          //inside statement "toyou"  (abnormal)
                   
       if (wasrem)                        //if control from remote
          {
           if ((!press)&&(bigcount==2)) release++;  //waiting of release of remote
           if (!release) goto RESCOU;     //waiting of release of remote and reset cou
          }
          
          


     
 serv1 = 0;
         if (press)                       //if button is pressed
          {
              if (depr>5)                 // if was depressed over 50mS
                {      
                  cou1++;                 //counter of time of second pressing
                      if (cou1>5)         //was double click
                       {
                        onoff();          //on whith memorized bright after doubleclick
                        goto NOTRESCOU1;  //reset 'cou' and 'depr' but not 'cou1' 
                        }
                      else goto EXIT;     // waiting untill 'cou1' becomes over 5
                 } 
                   
               else                       //was pressed continiousely
                {
                 cou++;                   //how long is pressed in first time
                 if (cou>=45)  slide ();  //pressed continiousely (over 450mS).
                 goto EXIT;               // waiting untill 'cou' becomes over 45
                 } 
           }
                  
          else                         //if button isn't pressed
          {
            if (cou1 != 0) goto RESCOU;//if was doubleclick then reset 'cou','cou1','depr'.
            
              if (cou>10&&cou<45) //if first pressing was short (less than 450mS)
               {
                depr++;           //counter of time of pause after first pressing
                     if (depr>35) //was only one click.Time of waiting of second click is over 350mS
                     {  
                            if (DEL == max)  //if turned off
                              {
                               serv1 = 255;  //see onoff(). Bright goes to maximum
                               onoff();
                              }
                            else
                              {
                               serv1 = 250;  //see onoff(). Bright goes to minimum
                               onoff();      //if turned off then turn on
                              }
                       goto RESCOU;    //if was only one click then reset 'cou','cou1','depr'.  
                     }
                     else goto EXIT;   //waiting untill 'depr' becomes over 35.Was only one click
                }
                 
              else goto RESCOU;//if 'cou' less than 10. Pressind was very short (less than 100mS)
           }
           
       RESCOU:      cou1=0;//all resets
       NOTRESCOU1:  cou=0;//cou1 don't resets
                    depr=0;
                    
      EXIT://nothing resets   
     ////////////////////////////////////////////////////////////////////////////////
     
   
  //changing of direction of regulating (rize-dime) when button or remote is pressed  
      if (count==1)//after 10mS after pressing
       {
         if((!wasrem) || ((wasrem)&&(release))) direction=!direction;
       }   
          
                
                //end of slide or short pressing
               //inside TOYOU statement.After 490mS after depressing
               //bigcount==49 (NEEDED FOR DOUBLECLICK) after bogcount==51 toyou becomes 0
          if ((bigcount==49)&&(DEL!=readmem (1)))//after bogcount==3   2
            {         
             serv1 = DEL;
             writemem (1);      //let's memo, then read after restart from WDT
             }
       
  }  //end "if (toyou)"
   
      
        if (DEL<min) DEL=min;    //limit of maximum bright
                
        if (DEL>max) DEL=max;    //protection of DEL from overflow.
                                 //limit of minimum bright
   
        
             //bigcount==2 (NEEDED FOR DOUBLECLICK)
    if (bigcount==2)//after 0.02s from !press  20
     {
        if (wasslide)
        {
         serv1 = DEL;
         writemem (0);  //new memorized bright
         }
      wasslide=0;       //reset of indicator "was slide"
     }
     
     
      if ((DEL==max)&&(wasslide))  DEL=DEL-2; //if was slide and bright is minimum 
                                              //then must still on
                                              



      
      
                                          
          impulse();        //impulse to triac
                                             
       if (wassub)          //if was in end of subroutine 'impulse'.
       {       
        __clear_watchdog_timer();
        wassub=0;
        }                                    
            
        
     goto LOOP;            //ethernal loop
     
}
